//
//  Animal.java
//  design by numbers 01
//
//  Created by Harry Vermeulen on 4/22/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

import java.io.IOException;
import java.awt.Color;
import com.lowagie.text.*;
import com.lowagie.text.pdf.*;

public class Animal {
	//Declarations
	Painter p;
	NumberGenerator n = new NumberGenerator();
	
	//Constructor
	public Animal(Painter painter) {
		p = painter;
	}
	
	//Old drawAnimalRandom function (not used in current file).
	//Draws an animal at a random position, with random Cyan and Magenta values.
	void drawAnimalRandom(int organs, int size) {
		int a = (int) (Math.random() * p.getPageWidth());
		int b = (int) (Math.random() * p.getPageHeight());
		Point spines[] = new Point[organs];
			
		for (int i = 0; i < organs; i++) {
			CMYKColor colorOrgans = new CMYKColor((float) Math.random(), (float) Math.random(), 0f, 0f);
			
			for (int j = 0; j < size; j++) {
				p.drawLine(n.rrc(a, b, size), n.rrc(a, b, size), 20f, (int) (Math.random() * 10), colorOrgans);
			}
			spines[i] = new Point(a, b);
			a = (int) (a + size * (Math.random() - 0.5));
			b = (int) (b + size * (Math.random() - 0.5));
		}
		
		for (int i = 0; i < organs - 1; i++) {
			p.drawLine(spines[i], spines[i+1], 100f, 1, new CMYKColor(1f, 0.2f, 0f, 0f));
			for (int j = 0; j < organs - 1; j++) {
				p.drawLine(new Point((float) (spines[i].x() + (Math.random() - 0.5) * 50),
						   (float) (spines[i].y() + (Math.random() - 0.5) * 50)), 
						   new Point((float) (spines[i+1].x() + (Math.random() - 0.5) * 50),
						   (float) (spines[i+1].y() + (Math.random() - 0.5) * 50)),
						   10, 10, new CMYKColor(1f, 0.2f, 0f, 0f));
			}
		}
	}
	
	//Old drawAnimalPosition function (not used anymore).
	//Draws an animal at a given position.
	void drawAnimalPosition(Point position, int organs, int size, CMYKColor colorOrgans, CMYKColor colorSpine) {
		int a = (int) position.x();
		int b = (int) position.y();
		Point spines[] = new Point[organs];
		
		for (int i = 0; i < organs; i++) {
			for (int j = 0; j < (size / 2); j++) {
				p.drawLine(n.rrc(a, b, size), n.rrc(a, b, size), 50, (int) (Math.random() * 10), colorOrgans);
			}
			for (int k = 0; k < (size / 20); k++) {
				p.drawLine(n.rrc(a, b, size), n.rrc(a, b, size), 50, (int) (Math.random() * 10), colorSpine);
			}
			
			spines[i] = new Point(a, b);
			a = (int) (a + size * (Math.random() - 0.5));
			b = (int) (b + size * (Math.random() - 0.5));
		}
		
		for (int i = 0; i < organs - 1; i++) {
			p.drawLine(spines[i], spines[i+1], 100, 1, colorSpine);
			for (int j = 0; j < organs - 1; j++) {
				p.drawLine(new Point((float) (spines[i].x() + (Math.random() - 0.5) * 50),
									 (float) (spines[i].y() + (Math.random() - 0.5) * 50)), 
						   new Point((float) (spines[i+1].x() + (Math.random() - 0.5) * 50),
									 (float) (spines[i+1].y() + (Math.random() - 0.5) * 50)),
						   10, organs / 5, colorSpine);
			}
		}
	}
	
	//Draws an animal at a given position with beziers instead of lines. Also automatically calls functions
	//to draw the eyes and a random name.
	void drawAnimalPositionBezier(Point position, int organs, int size, int eyes, CMYKColor colorOrgans, CMYKColor colorSpine, CMYKColor colorEyeBrow) {
		float eyeSize;
		
		//Symplifying long functions to a and b variables
		int a = (int) position.x();
		int b = (int) position.y();
		
		//Array to keep track of the center of random generated organs
		Point spines[] = new Point[organs];
		
		//Drawing organs and filling up the array with locations
		for (int i = 0; i < organs; i++) {
			for (int j = 0; j < (size / 20); j++) {
				p.drawBezier(n.rrc(a, b, size), 
							 n.rrc(a, b, size), 
							 n.rrc(a, b, size), 
							 n.rrc(a, b, size),
							 30, (int) (Math.random() * 50), colorOrgans);
			}
			
			spines[i] = new Point(a, b);
			a = (int) (a + size * (Math.random() - 0.5));
			b = (int) (b + size * (Math.random() - 0.5));
		}
		
		//Using locations to draw the spines between organs
		for (int i = 0; i < organs - 1; i++) {
			p.drawLine(spines[i], spines[i+1], 100, 1, colorSpine);
			for (int j = 0; j < (organs / 2) - 1; j++) {
				p.drawBezier(new Point((float) (spines[i].x() + (Math.random() - 0.5) * 50),
									   (float) (spines[i].y() + (Math.random() - 0.5) * 50)), 
						     new Point((float) (spines[i+1].x() + (Math.random() - 0.5) * 50),
									   (float) (spines[i+1].y() + (Math.random() - 0.5) * 50)),
							 new Point((float) (spines[i].x() + (Math.random() - 0.5) * 50),
									   (float) (spines[i].y() + (Math.random() - 0.5) * 50)), 
							 new Point((float) (spines[i+1].x() + (Math.random() - 0.5) * 50),
									   (float) (spines[i+1].y() + (Math.random() - 0.5) * 50)), 	 
						   10, organs / 5, colorSpine);
			}
		}
		
		//Drawing tentacles
		for (int i = 0; i < organs; i++) {
			p.drawBezier(n.rrc(a, b, size * 3), n.rrc(a, b, size * 3), spines[i], n.rrc(a, b, size * 3), 10, (int) (Math.random() * 3), colorOrgans);
		}
		
		//Calculating eyesize
		eyeSize = (float) (Math.random() * size / 5 + 15);
		for (int i = 0; i < eyes; i++) {
			p.drawEye(position, size, eyeSize, colorOrgans, colorSpine, colorEyeBrow);
		}

		p.rectangle(position.x() - (size + 6),
					position.y() - (size * 2 + 30),
					organs * 3.5f + 30,
					50);
	}
}
