//
//  design_by_numbers_01.java
//  design by numbers 01
//
//  Created by Harry Vermeulen on 4/21/07.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

import com.lowagie.text.pdf.*;

public class design_by_numbers_01 {
    public static void main (String args[]) {		
		//Declarations
		ColorLib c = new ColorLib(); //Library with some colors.
		Point po;
		int size;
		float personalSize;
		int organs;
		int eyes;
		
		//Settings
		String fileName = "design_by_numbers_08.pdf"; //filename for the pdf document
		int coloms = 10; //amount of coloms
		int rows = (int) (coloms * 1.5); //1.5 is a nice relation to coloms for a portrait A0 format.
		float xMargin = 200f; //defined in mm.
		float yMargin = 200f; //defined in mm.
		
		//Makes the painter and opens the pdf file.
		Painter p = new Painter(fileName); //Makes a painter and opens the pdf file.
		Animal animal = new Animal(p); //Links the animal class to the painter.
		
		//Size of the animals (abstract value).
		personalSize = 1f; //1f is for normal results. Lower for smaller and raise for bigger animals.
		
		//Don't touch the next line!
		size = (int) ((p.getPageWidth() - (2 * xMargin)) / (coloms * (6 / personalSize))); 
		
		//Loop that makes the animals.
		for (int i = 0; i < coloms; i++) {
			for (int j = 0; j < rows; j++) {
				//Position of the animal, distributed over the paper.
				po = new Point((float) (((p.getPageWidth() - (xMargin * 2)) / coloms) * (i + 0.5) + xMargin),
							   (float) (((p.getPageHeight() - (yMargin * 2.2)) / rows) * (j + 0.5) + (yMargin * 1.3)));
				
				//amount of organs for the animal.
				organs = (int) (Math.random() * 25 + 1); 				
				//amount of eyes for the animal.
				eyes = (int) (Math.random() * 2) + 1; 
				//animal class calculates shape of the animal and calls the painter.
				animal.drawAnimalPositionBezier(po, organs, size, eyes, c.black, c.blue, c.yellow);
				//draws a random generated name(taking into account size and amount of organs) 
				//at the position of the animal.
				p.drawRandomName(po, size, organs);
			}
		}
		//closes the pdf document
		p.closeDocument();
	}
}